# Interface XECPrivateKey

All Superinterfaces:
  `AsymmetricKey, DEREncodablePREVIEW, Destroyable, Key, PrivateKey, Serializable, XECKey`

public interface XECPrivateKey extends XECKey, PrivateKey
An interface for an elliptic curve private key as defined by RFC 7748. These keys are distinct from the keys represented by `ECPrivateKey`, and they are intended for use with algorithms based on RFC 7748 such as the XDH `KeyAgreement` algorithm. An XEC private key is an encoded scalar value as described in RFC 7748. The decoding procedure defined in this RFC includes an operation that forces certain bits of the key to either 1 or 0. This operation is known as "pruning" or "clamping" the private key. Arrays returned by this interface are unpruned, and implementations will need to prune the array before using it in any numerical operations.

Since:
  11

## Field Summary

### Fields declared in interface PrivateKey

`serialVersionUID`
Modifier and Type
Field
Description
`static final long`
`serialVersionUID`
Deprecated.
A `serialVersionUID` field in an interface is ineffectual.

## Method Summary

Modifier and Type
Method
Description
`default AlgorithmParameterSpec`
`getParams()`
Returns the parameters associated with this key.
`Optional<byte[]>`
`getScalar()`
Get the scalar value encoded as an unpruned byte array.

### Methods declared in interface Destroyable

`destroy, isDestroyed`
Modifier and Type
Method
Description
`default void`
`destroy()`
Destroy this `Object`.
`default boolean`
`isDestroyed()`
Determine if this `Object` has been destroyed.

### Methods declared in interface Key

`getAlgorithm, getEncoded, getFormat`
Modifier and Type
Method
Description
`String`
`getAlgorithm()`
Returns the standard algorithm name for this key.
`byte[]`
`getEncoded()`
Returns the key in its primary encoding format, or `null` if this key does not support encoding.
`String`
`getFormat()`
Returns the name of the primary encoding format of this key, or `null` if this key does not support encoding.

## Method Details

### getScalar

Optional<byte[]> getScalar()
Get the scalar value encoded as an unpruned byte array. A new copy of the array is returned each time this method is called.

Returns:
  the unpruned encoded scalar value, or an empty Optional if the scalar cannot be extracted (e.g. if the provider is a hardware token and the private key is not allowed to leave the crypto boundary).

### getParams

default AlgorithmParameterSpec getParams()
Returns the parameters associated with this key. The parameters are optional and may be either explicitly specified or implicitly created during key pair generation.

Specified by:
  `getParams` in interface `AsymmetricKey`
Specified by:
  `getParams` in interface `XECKey`
Implementation Requirements:
  The default implementation returns `null`.
Returns:
  the associated parameters, may be `null`